%% Newtonverfahren mit Armijo-Schrittweite:

function [xk,fxk] = newtonverfahren(f,x0,tol)

    xk = x0;
    steps = 0;
    [~,gk,~] = f(xk);                                                      % exakten Gradienten bestimmen

    while norm(gk) > tol
    
        steps = steps + 1;
        [~,~,Hk] = f(xk);
        
        if det(Hk) ~= 0
        
            dk = (-Hk\gk');                                                % Suchrichtung setzen, falls System lösbar
            
            if gk*dk >= 0
            
                dk = -gk';                                                 % Gradienten als Richtung, falls keine Abstiegsrichtung
            
            end
            
        else
            
            dk = -gk';                                                     % Suchrichtung setzen, falls System nicht lösbar
            
        end
        
        tk = schrittweite_armijo(f,xk,dk);                                 % Armijo Schrittweite ermitteln
        
        xk = xk + tk*dk;                                                   % Iterationsschritt
        
        [~,gk,~] = f(xk);                                                  % exakten Gradienten bestimmen
        
    end
    
    fxk = f(xk);

end